=== criu/arch/arm/Makefile ===
builtin-name		:= crtools.built-in.o

ccflags-y		+= -iquote $(obj) -iquote $(SRC_DIR) -iquote $(obj)/include -iquote $(SRC_DIR)/criu/include

obj-y			+= cpu.o
obj-y			+= crtools.o
