=== test/others/criu-coredump/Makefile ===
run: clean
	./test.sh

clean:
	rm -f *.img stats-* core.*
