=== debian/changelog ===
criu (2.6-1ubuntu1~ubuntu16.04.2) xenial; urgency=medium

  * Drop versioned build-dep on debhelper 10.
    Couldn't find a reason for the >= 10 requirement and prevents
    building on 16.04.

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 15 Nov 2016 11:55:26 -0500

criu (2.6-1ubuntu1~ubuntu16.04.1) xenial; urgency=medium

  * SRU of current CRIU 2.6 to Xenial. (LP: #1634245)
    This is needed for 4.8 kernel support as well as to deal with
    AppArmor profile stacking.

 -- Stéphane Graber <stgraber@ubuntu.com>  Mon, 17 Oct 2016 15:51:46 -0400

criu (2.6-1ubuntu1) yakkety; urgency=medium

  * Cherry-pick upstream cgroup fixes:
    - 0002-cgroup-treat-devices-as-special-properties.patch
    - 0003-cgroup-support-cgroup-root-on-dump-too.patch
    - 0004-cgroup-only-reset-directory-when-dirnew-is-valid.patch
    - 0005-doc-document-cgroup-root-on-dump.patch

  * Cherry-pick apparmor stacking support:
    - 0006-lsm-move-apparmor-securityfs-path-to-constant-in-lsm.patch
    - 0007-lsm-support-checkpoint-restore-of-stacked-apparmor-p.patch
    - 0008-check-add-a-feature-test-for-apparmor_stacking.patch
    - 0009-lsm-add-support-for-rewriting-apparmor-profiles.patch
    - 0010-tests-add-a-test-for-apparmor_stacking.patch
    - 0011-images-add-syntax-specifier-to-autofs.proto.patch
    - 0012-inventory-lsm-remember-to-set-has_lsmtype.patch
    - 0013-images-rename-NONE-to-CG_NONE.patch

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 05 Oct 2016 07:51:19 +0200

criu (2.6-1) experimental; urgency=medium

  * New upstream version 2.6
  * Bump Debhelper compat level to 10

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 13 Sep 2016 08:06:16 +0200
