=== debian/control ===
Source: criu
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Build-Depends:
 asciidoc,
 debhelper,
 dh-python,
 libcap-dev,
 libnl-3-dev,
 libprotobuf-c-dev,
 libprotobuf-dev,
 protobuf-c-compiler,
 protobuf-compiler,
 python-all (>= 2.6.6-3~),
 xmlto
Standards-Version: 3.9.8
Homepage: http://www.criu.org/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/criu.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/criu.git

Package: criu
Architecture: amd64 armhf ppc64el
Depends: python-ipaddr, python-protobuf, ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Recommends: iproute2 | iproute
Description: checkpoint and restore in userspace
 criu contains the utilities to checkpoint and restore processes in
 userspace.
