=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=-all

PACKAGE = $(firstword $(shell dh_listpackages))
TMP     = $(CURDIR)/debian/$(PACKAGE)

%:
	dh ${@} --parallel --with python2

override_dh_auto_install:
	dh_auto_install -- DESTDIR="$(CURDIR)/debian/criu" PREFIX="/usr" LIBEXECDIR="/usr/lib"
	# remove empty directories as spotted by lintian
	# /usr/lib/systemd/system should not be installed
	find $(TMP)/usr/lib -type d -empty -delete

override_dh_auto_test:
	# disabled: doesn't work yet

override_dh_strip:
	dh_strip --ddeb-migration='criu-dbg (<< 1.8-2~)'
