=== debian/watch ===
version=3
opts=uversionmangle=s/-rc/~rc/ \
http://download.openvz.org/criu/criu-(.*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
