## criu 2.8

=== debian/changelog ===
criu (2.8-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 28 Nov 2016 13:30:09 +0100

criu (2.8-1) experimental; urgency=medium

  * New upstream version 2.8
  * debian/rules: Build enabling all hardening flags.
    Fixes "FTBFS: ld: unrecognized option
    '-specs=/usr/share/dpkg/no-pie-link.specs'"
    Thanks to Adrian Bunk <bunk@stusta.de> (Closes: #844293)

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 28 Nov 2016 08:40:13 +0100

criu (2.7-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 17 Oct 2016 20:13:09 +0200

criu (2.7-1) experimental; urgency=medium

  * New upstream version 2.7
  * Update copyright years for upstream files

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 17 Oct 2016 10:47:15 +0200

criu (2.6-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 08 Oct 2016 19:54:24 +0200
