=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: criu
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
+Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends:
  asciidoc,
- debhelper,
+ debhelper (>= 10),
  dh-python,
  libcap-dev,
  libnl-3-dev,
