## criu 2.9

=== debian/changelog ===
criu (2.9-2ubuntu1) zesty; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Build without PIE.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 15 Jan 2017 10:38:27 +0530

criu (2.9-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 26 Dec 2016 10:49:35 +0100

criu (2.9-1) experimental; urgency=medium

  * New upstream version 2.9
  * Install crit.1 provided by upstream

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 13 Dec 2016 21:20:16 +0100

criu (2.8-2ubuntu1) zesty; urgency=medium

  * debian/rules: Build without -pie

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 11 Dec 2016 02:52:14 -0500
