## criu 2.12

=== debian/changelog ===
criu (2.12-1ubuntu1) zesty; urgency=medium

  * Merge from Debian experimental.  Remaining changes:
    - Build without PIE.

 -- Stéphane Graber <stgraber@ubuntu.com>  Mon, 20 Mar 2017 19:43:24 -0400

criu (2.12-1) experimental; urgency=medium

  * New upstream version 2.12

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 10 Mar 2017 12:28:16 +0100

criu (2.11.1-1) experimental; urgency=medium

  * New upstream version 2.11.1
  * debian/rules: Cleanup dh_auto_install override.
    No need anymore to manually clean up /usr/lib/systemd/system, since not
    installed anymore by upstream.

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 02 Mar 2017 10:16:48 +0100

criu (2.10-1) experimental; urgency=medium

  * New upstream version 2.10
  * Update copyright years for debian/* packaging files
  * Drop 0001-build-nmk-Filter-out-Wl-flags-from-linking-builtin-t.patch
  * Add Build-Depends on libnet1-dev

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 19 Jan 2017 20:50:21 +0100
