=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: criu
 Section: admin
 Priority: optional
-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends:
  asciidoc,
  debhelper (>= 10),
  dh-python,
  libcap-dev,
+ libnet1-dev,
  libnl-3-dev,
  libprotobuf-c-dev,
  libprotobuf-dev,
