=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,6 @@
 
 override_dh_auto_install:
 	dh_auto_install -- DESTDIR="$(CURDIR)/debian/criu" PREFIX="/usr" LIBEXECDIR="/usr/lib"
-	# remove empty directories as spotted by lintian
-	# /usr/lib/systemd/system should not be installed
-	find $(TMP)/usr/lib -type d -empty -delete
 
 override_dh_auto_test:
 	# disabled: doesn't work yet
