## criu 2.12.1

=== criu/arch/arm/Makefile ===
builtin-name		:= crtools.built-in.o

ccflags-y		+= -iquote $(obj) -iquote $(SRC_DIR) -iquote $(obj)/include
ccflags-y		+= -iquote $(SRC_DIR)/criu/include -iquote $(SRC_DIR)/include

asflags-y		+= -D__ASSEMBLY__

obj-y			+= cpu.o
obj-y			+= crtools.o
obj-y			+= sigframe.o
obj-y			+= bitops.o
