=== test/others/pipes/Makefile ===
CFLAGS += -Wall
pipe: pipe.c
clean:
	rm -f pipe
run: pipe
	./pipe - &&		\
	./pipe -c &&		\
	./pipe -cl &&		\
	./pipe -d &&		\
	./pipe -o &&		\
	./pipe -r &&		\
	./pipe -dc &&		\
	./pipe -dcl &&		\
	true
