=== debian/changelog ===
criu (2.12.1-2ubuntu1) artful; urgency=medium

  * Build without PIE specifically on armhf and fix FTBFS.
    (even though latest dpkg supports PIE on ubuntu).

 -- Bhavani Shankar <bhavi@ubuntu.com>  Tue, 25 Apr 2017 08:21:38 +0530

criu (2.12.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 15 Apr 2017 17:22:39 +0200

criu (2.12.1-1) experimental; urgency=medium

  * New upstream version 2.12.1

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 03 Apr 2017 09:07:19 +0200
