=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,12 @@
 #!/usr/bin/make -f
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+
+ifeq ($(DEB_BUILD_ARCH), $(filter $(DEB_BUILD_ARCH), armhf))
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
+endif
 
 PACKAGE = $(firstword $(shell dh_listpackages))
 TMP     = $(CURDIR)/debian/$(PACKAGE)
